#pragma once
#include "ViewWin.h"
#include "resource.h"

class CMainFrame :
  public CWindowImpl<CMainFrame, CWindow, CFrameWinTraits>
{
public:
  CMainFrame(void);
  ~CMainFrame(void);

public:
	CViewWin m_wndView;

  void OnFinalMessage(HWND /*hWnd*/)
  {
   ::PostQuitMessage(0);
  }

DECLARE_WND_CLASS(_T("MyFrame"))

BEGIN_MSG_MAP(CMainFrame)
		MESSAGE_HANDLER(WM_CREATE, OnCreate)
		MESSAGE_HANDLER(WM_SIZE, OnSize)
		COMMAND_ID_HANDLER(ID_SETCOLOR_RED, OnSetColorRed)
		COMMAND_ID_HANDLER(ID_SETCOLOR_GREEN, OnSetColorGreen)
		COMMAND_ID_HANDLER(ID_SETCOLOR_BLUE, OnSetColorBlue)
END_MSG_MAP()  

	LRESULT OnCreate(UINT uMsg, WPARAM wParam, 
		LPARAM lParam, BOOL& bHandled)
	{
		m_wndView.Create(m_hWnd, CWindow::rcDefault, _T("MyView"));
		return 0;
	}

  LRESULT OnSize(UINT uMsg, WPARAM wParam,
                 LPARAM lParam, BOOL& bHandled)
  {
   RECT r;
   GetClientRect(&r);

   m_wndView.SetWindowPos(NULL, &r,
                          SWP_NOZORDER | SWP_NOACTIVATE );
   
   return 0;
  }

   LRESULT OnSetColorRed(WORD wNotifyCode, 
                      WORD wID,
                      HWND hWndCtl, 
                      BOOL& bHandled)
   {
    m_wndView.m_color = RGB(255,0,0);
    return 0;
   }

   LRESULT OnSetColorGreen(WORD wNotifyCode, 
                      WORD wID,
                      HWND hWndCtl, 
                      BOOL& bHandled)
   {
    m_wndView.m_color = RGB(0,255,0);
    return 0;
   }

   LRESULT OnSetColorBlue(WORD wNotifyCode, 
                      WORD wID,
                      HWND hWndCtl, 
                      BOOL& bHandled)
   {
    m_wndView.m_color = RGB(0,0,255);
    return 0;
   }
};
